#include "graph_lib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>


void g_add_square( graph_t *graph, int a, int b, int c, int d ) {
	g_add_edge( graph, a, b );
	g_add_edge( graph, b, c );
	g_add_edge( graph, c, d );
	g_add_edge( graph, d, a );
}



int main(int argc, char *argv[])
{
	graph_t *graph;
	


	/* orig0
	//
	//      +--+-a
	//      |  |
	//    a-+--+
	//
		graph = g_create( 4 );
		g_add_square( graph, 0, 1, 2, 3 );
		g_add_edge( graph, 1, 3 );
		g_write_to_file( graph, stdout );
		g_destroy( &graph );
	/*/
	
	//*orig1
	//
	//    a-+--+--+--+
	//      |  |  |  |
	//      +--+--+--+--+-a
	//
		graph = g_create( 9 );
		g_add_square( graph, 0, 1, 2, 3 );
		g_add_square( graph, 4, 5, 6, 7 );
	
		g_add_edge( graph, 1, 4 );
		g_add_edge( graph, 2, 7 );
		g_add_edge( graph, 0, 8 );
		g_add_edge( graph, 8, 6 );
		
		g_write_to_file( graph, stdout );
		g_destroy( &graph );
	//*/



	/*orig1
		graph = g_create( 8 );
		g_add_square( graph, 0, 1, 2, 3 );
		g_add_square( graph, 4, 5, 6, 7 );
	
		g_add_edge( graph, 1, 4 );
		g_add_edge( graph, 2, 7 );
		g_add_edge( graph, 0, 5 );
//		g_add_edge( graph, 3, 6 );
		
		g_write_to_file( graph, stdout );
		g_destroy( &graph );
	/*/
	

	/*orig2
		graph = g_create( 10 );
		g_add_square( graph, 0, 1, 8, 9 );
		g_add_square( graph, 3, 4, 5, 6 );
	
		g_add_edge( graph, 1, 2 );
		g_add_edge( graph, 2, 3 );
		g_add_edge( graph, 6, 7 );
		g_add_edge( graph, 8, 7 );

		g_add_edge( graph, 9, 4 );
		g_add_edge( graph, 0, 5 );
		
		g_write_to_file( graph, stdout );
		g_destroy( &graph );
	/*/
	

	/*
	//
	//    +--+--+--+--+
	//    |  |  |  |  |
	//  a-+--+--+--+--+-a
	//
	//
		graph = g_create( 12 );
		g_add_square( graph, 0, 1, 2, 3 );
		g_add_square( graph, 4, 5, 6, 7 );
		g_add_square( graph, 8, 9, 10, 11 );
		
		g_add_edge( graph, 1, 4 );
		g_add_edge( graph, 5, 8 );
		g_add_edge( graph, 6,11 );
		g_add_edge( graph, 2, 7 );

		g_add_edge( graph, 0, 9 );
		
		g_write_to_file( graph, stdout );
		g_destroy( &graph );
	/*/





	return 0;	
}
